<script lang="ts">
import { defineComponent } from "vue";
import type { PropType } from "vue";
import * as cd from "../lib/chordDictionary";
import type { ChordName } from "../lib/chordDictionary";

export default defineComponent({
  props: {
    chordNames: { type: Object as PropType<Array<string>> },
    scale: { type: Number, required: true },
  },
  computed: {
    names() {
      // chord name
      const ret: Array<ChordName> = [];
      this.chordNames?.forEach((chordName) => {
        ret.push(cd.parseChordName(chordName));
      });
      return ret;
    },
  },
});
</script>
<template>
  <transition name="chord_tx" appear>
    <div
      v-if="names.length > 0"
      class="name"
      :style="{ 'font-size': scale * 0.45 + 'em' }"
    >
      <template v-for="(name, idx) in names" :key="name.name">
        {{ name.name }}<sup v-if="name.voicing">{{ name.voicing }}</sup>
        <template v-if="idx < names.length - 1"><br /></template>
      </template>
    </div>
  </transition>
</template>
<style scoped>
.name {
  font-weight: bold;
  text-anchor: middle;
  color: var(--secondary);
  font-family: verdana, sans-serif;
  text-align: center;
  max-height: fit-content;
  padding-bottom: 0.4em;
}

.chord_tx-enter-active {
  transition: all 1s;
}
.chord_tx-leave-active {
  transition: all 1s;
}

.chord_tx-enter-from,
.chord_tx-leave-to {
  max-height: 0;
  opacity: 0;
}
</style>
